import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import React, { useState, useEffect, useRef, useCallback } from 'react';
import { useConsent } from '@s-ui/react-tcf-services';
import SuiButton from '@s-ui/react-atom-button';
import SuiModal from '@s-ui/react-molecule-modal';
import SuiNotification from '@s-ui/react-molecule-notification';
import IconClose from './iconClose';
import { I18N } from './settings';
var CLASS = 'sui-TcfFirstLayer';
var SCROLL_TO_ACCEPT = 250;
export default function TcfFirstLayer(_ref) {
  var logo = _ref.logo,
      saveUserConsent = _ref.saveUserConsent,
      openSecondLayer = _ref.openSecondLayer,
      openCookiepolicyLayer = _ref.openCookiepolicyLayer,
      _ref$showInModalForMo = _ref.showInModalForMobile,
      showInModalForMobile = _ref$showInModalForMo === void 0 ? false : _ref$showInModalForMo;

  var _useConsent = useConsent(),
      isMobile = _useConsent.isMobile,
      language = _useConsent.language,
      loadUserConsent = _useConsent.loadUserConsent,
      updateUserConsent = _useConsent.updateUserConsent;

  var _useState = useState(true),
      show = _useState[0],
      setShow = _useState[1];

  var i18n = I18N[language];
  var handleCookiePolicyLayerClick = useCallback(function () {
    cookiesPolicyLink.current && cookiesPolicyLink.current.removeEventListener('click', handleCookiePolicyLayerClick);
    openCookiepolicyLayer();
  });
  var cookiesPolicyLink = useRef();
  var ref = useRef(null);
  var textRef = useCallback(function (node) {
    if (ref.current) {
      ref.current = null;
    }

    if (node) {
      cookiesPolicyLink.current = node.querySelector("." + CLASS + "-link");

      if (cookiesPolicyLink) {
        cookiesPolicyLink.current.addEventListener('click', handleCookiePolicyLayerClick);
      }

      ref.current = node;
    }
  }, [handleCookiePolicyLayerClick]);
  var initialYOffset;

  var checkScroll = function checkScroll() {
    if (initialYOffset - window.pageYOffset >= SCROLL_TO_ACCEPT || initialYOffset - window.pageYOffset <= -SCROLL_TO_ACCEPT) {
      handleSaveExitClick();
    }
  };

  useEffect(function () {
    initialYOffset = window.pageYOffset;
    document.addEventListener('scroll', checkScroll, {
      passive: true
    });
    return function () {
      return document.removeEventListener('scroll', checkScroll);
    };
  }, []);

  var handleSettingsClick = function handleSettingsClick() {
    openSecondLayer();
  };

  var handleSaveExitClick = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      var _yield$loadUserConsen, purpose, vendor, specialFeatures;

      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return loadUserConsent();

            case 2:
              _yield$loadUserConsen = _context.sent;
              purpose = _yield$loadUserConsen.purpose;
              vendor = _yield$loadUserConsen.vendor;
              specialFeatures = _yield$loadUserConsen.specialFeatures;
              updateUserConsent({
                purpose: purpose,
                vendor: vendor,
                specialFeatures: specialFeatures,
                allPurposes: true,
                allVendors: true,
                allSpecialFeatures: true
              });
              handleCloseModal();
              saveUserConsent();

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function handleSaveExitClick() {
      return _ref2.apply(this, arguments);
    };
  }();

  var handleCloseModal = function handleCloseModal() {
    setShow(false);
  };

  var Content = function Content() {
    return /*#__PURE__*/React.createElement("div", {
      className: CLASS + "-body"
    }, /*#__PURE__*/React.createElement("div", {
      className: CLASS + "-info",
      ref: textRef,
      dangerouslySetInnerHTML: {
        __html: i18n.BODY
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: CLASS + "-buttons"
    }, /*#__PURE__*/React.createElement(SuiButton, {
      onClick: handleSettingsClick,
      design: "outline"
    }, i18n.CONFIGURE_BUTTON), /*#__PURE__*/React.createElement(SuiButton, {
      onClick: handleSaveExitClick
    }, i18n.CONTINUE_NAVIGATION_BUTTON)));
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "" + (isMobile ? CLASS + " " + CLASS + "--isMobile" : "" + CLASS)
  }, isMobile && showInModalForMobile ? /*#__PURE__*/React.createElement(SuiModal, {
    isOpen: show,
    closeOnOutsideClick: true,
    closeOnEscKeyDown: true,
    header: /*#__PURE__*/React.createElement("img", {
      className: CLASS + "-logo",
      src: logo,
      alt: "logo"
    }),
    iconClose: /*#__PURE__*/React.createElement(IconClose, {
      "class": CLASS + "-icon-close"
    }),
    onClose: handleSaveExitClick,
    fitContent: true,
    portalContainerId: "sui-TcfFirstLayerModal"
  }, /*#__PURE__*/React.createElement(Content, null)) : /*#__PURE__*/React.createElement("div", {
    className: CLASS + "-notification"
  }, /*#__PURE__*/React.createElement(SuiNotification, {
    position: "bottom",
    autoClose: "manual",
    show: show,
    showCloseButton: false,
    variation: "positive",
    type: "system"
  }, /*#__PURE__*/React.createElement(Content, null))));
}
TcfFirstLayer.displayName = 'TcfFirstLayer';